/*! ********************************************
 * ProcessData.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox 
{
public class ProcessData 
{
	public var sampleRate    :Number = 44100.0;
	public var audioChannels :int = 2;
	public var blockSize     :int = 2048;  // Process Block Size (BufferSize)
	//public var blockPosition:int = 0;
	public var audioOut      :Vector.<Vector.<Number>> = null;
	public var midiEventList :MidiEvent = null;  // MIDIEvent List (Single Linked [ SampleFrame Order ])
	public var offsetFrames  :int = 0;  // From the First Frame in the Audio Process Block.
	public var sampleFrames  :int = 0;  // Number of Frames to Process ( * Current Process() )
	// option
	public var audioLatency  :Number = 0.0;  // Audio Output Latency [mSec]
	/*
	  [76543210] 8Bit Flags
	  [------ba] [1 = on][0 = off]
	  a -> GrayBox is Ready to Process.  <- from GrayBox.suspend() / .resume()
	  b -> GrayBox is Actived.           <- from GrayBox.start() / .stop()
	*/
	//public var processingStatus:int = 0;
	public function getMidiEvents():MidiEvent { return midiEventList.next; }
	public function addToMidiEventList(event:MidiEvent, check:Boolean = false):void
	{
		var _list:MidiEvent;
		// check ---
		if (check)
		{
			_list = midiEventList.next;
			while (_list)
			{
				if (_list == event) return;
				_list = _list.next;
			}
		}
		// add to list ---
		//event.next = null;
		_list = midiEventList;
		while (_list.next)
		{
			if (event.offsetFrames >= _list.next.offsetFrames) _list = _list.next;
			else break;
		}
		event.next = _list.next;
		_list.next = event;
	}
	//public function RemoveFromMidiEventList(event:MidiEvent):void{}
// Constructor
	public function ProcessData():void{}
}
}